#include <iostream>
//#include "exact.hpp"
#include "endian.hpp"
#include <climits>

#define SHOW(QQ) std::cout << #QQ << " =\t" << QQ << std::endl
#define SHOWREP(QQ) std::copy( (char*)&QQ, (char*)&QQ + sizeof(QQ), \
        std::ostream_iterator<unsigned>(SHOW(QQ) << "Internals:\t"," ") ), \
        std::cout << std::endl

template <typename T>
struct ops {};
struct ex : ops<ex> { char a[3]; };
struct wr : ops<wr> { ex x; };
//struct wp : opr { ex x; };
struct no { ex x; };

int main() {

    SHOW( sizeof(ops<void>) );
    SHOW( sizeof(ex) );
    SHOW( sizeof(wr) );
    SHOW( sizeof(no) );

    std::cout << std::showbase << std::hex;

    boost::big_endian< long > x = 0x12345678;
    boost::little_endian< long > y = 0x21436587;
    boost::big_endian< boost::exact<24> > z = -2;
    boost::big_endian< boost::exact<24,unsigned> > w = 7;

    SHOW( sizeof( long ) );
    SHOW( sizeof( boost::big_endian< long > ) );
    SHOW( sizeof( boost::exact<24> ) );
    SHOW( sizeof( boost::big_endian< boost::exact<24> > ) );

/*    
    SHOW( x );
    SHOW( y );
    SHOW( z );
    SHOW( w );
*/
    SHOWREP(x);
    SHOWREP(y);
    SHOWREP(z);
    SHOWREP(w);
}
