#include <iostream>
#include "exact.hpp"
#include <climits>

#define SHOW(x) std::cout << #x << " =\t" << x << std::endl;

int main() {

//    std::cout << std::hex;

    boost::exact<16> w = -1;
    boost::exact<24,unsigned> x = -1;
    boost::exact<32,signed> y = -1;
    boost::exact<8,signed,16> z = -1;

    SHOW( w );
    SHOW( x );
    SHOW( y );
    SHOW( z );

    SHOW( CHAR_BIT*sizeof( boost::exact<24>[2] ) );
    SHOW( CHAR_BIT*sizeof( boost::exact<24,signed,16>[2] ) );
    SHOW( CHAR_BIT*sizeof( boost::exact<32,unsigned>[2] ) );
    SHOW( CHAR_BIT*sizeof( boost::exact<8,unsigned,16>[2] ) );
    SHOW( CHAR_BIT*sizeof( boost::exact<8,signed,32>[2] ) );

    SHOW(( std::numeric_limits< boost::exact<24> >::min() ));
    SHOW(( std::numeric_limits< boost::exact<24> >::min()-1 ));
    SHOW(( std::numeric_limits< boost::exact<24> >::max() ));
    SHOW(( std::numeric_limits< boost::exact<24> >::max()+1 ));
    SHOW(( std::numeric_limits< boost::exact<24,unsigned> >::min() ));
    SHOW(( std::numeric_limits< boost::exact<24,unsigned> >::max() ));

    SHOW(( std::numeric_limits< boost::exact< 8,  signed> >::max() ));
    SHOW(( std::numeric_limits< boost::exact< 8,  signed> >::digits10 ));
    SHOW(( std::numeric_limits< boost::exact< 8,unsigned> >::max() ));
    SHOW(( std::numeric_limits< boost::exact< 8,unsigned> >::digits10 ));
    SHOW(( std::numeric_limits< boost::exact<16,unsigned> >::max() ));
    SHOW(( std::numeric_limits< boost::exact<16,unsigned> >::digits10 ));
    SHOW(( std::numeric_limits< boost::exact<24,  signed> >::max() ));
    SHOW(( std::numeric_limits< boost::exact<24,  signed> >::digits10 ));
    SHOW(( std::numeric_limits< boost::exact<24,unsigned> >::max() ));
    SHOW(( std::numeric_limits< boost::exact<24,unsigned> >::digits10 ));
    SHOW(( std::numeric_limits< boost::exact<32,unsigned> >::max() ));
    SHOW(( std::numeric_limits< boost::exact<32,unsigned> >::digits10 ));

}
